function [DF] = dataflowgen(CTT,no_flows,no_sources)
%DATAFLOWGEN random generation of data flows in a given topology
%
% Parameters:
%   CTT     adjacency matrix - description of cluster-tree topology CTT
%   (logical topology) - parent-child relation
%   no_flows    total number of data flows  
%   no_sources  total number of sources of each data flow
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

node_id = [1:length(CTT)];
for i=1:no_flows 
    if length(node_id)<no_sources+1
        node_id = [1:length(CTT)];
    end
    idx = ceil(length(node_id)*rand); %random number
    DF(i).sink = node_id(idx);   %random sink
    node_id(idx)= []; %remove sink
    
    DF(i).sources = [];
    for j=1:no_sources
        idx = ceil(length(node_id)*rand); %random number
        DF(i).sources = [DF(i).sources, node_id(idx)];
        node_id(idx)= []; %remove sink
    end
    
    DF(i).deadline = 150;
    DF(i).sample_period = 0.6; 
    DF(i).sample_size = 120;
	DF(i).ack = false;    
end
