function matrix2glpk(fid,data,name,posinf,neginf,format)
%Function generates elementary parameters of GNU MatProg ILP models.
%
% PARAMETERS:
%  fid           
%  data          
%  name         
%  posinf        
%  neginf        
%  format         
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if(~exist('format','var'))
    if(size(data,1)==1 & size(data,2)==1)
        format = 'scalar';
    elseif(size(data,1)==1 | size(data,2)==1)
        format = 'vector';
    else
        format = 'matrix';
    end
end

if(strcmp(format,'scalar'))
    %Write a scalar
    if data == -Inf
        fprintf(fid,'param %s := %s;\n\n',name,neginf);
    elseif data == +Inf
        fprintf(fid,'param %s := %s;\n\n',name,posinf);
    else
        fprintf(fid,'param %s := %d;\n\n',name,data);
    end
elseif(strcmp(format,'vector'))
    %Write a vector
    fprintf(fid,'param %s := \n',name);
    for(i=1:length(data))
        if data(i) == -Inf
            fprintf(fid,'%d %s\n',i,neginf);
        elseif data(i) == +Inf
            fprintf(fid,'%d %s\n',i,posinf);
        else
            fprintf(fid,'%d %d\n',i,data(i));
        end
    end
    fprintf(fid,';\n\n');
else
    %Write a matrix
    fprintf(fid,'param %s : \n',name);
    for(i=1:size(data,2))
        fprintf(fid,'\t%d',i);
    end
    fprintf(fid,' :=\n');
    for(i=1:size(data,1))
        fprintf(fid,'%d\t',i);
        for(j=1:size(data,2))
            if data(i,j) == -Inf
                fprintf(fid,'%s\t',neginf);
            elseif data(i,j) == +Inf
                fprintf(fid,'%s\t',posinf);
            else
                fprintf(fid,'%d\t',data(i,j));
            end
            
        end
        fprintf(fid,'\n');
    end
    fprintf(fid,';\n\n');
end

%end of file
