function zigplot(p,dedication,task_labels,proc_labels,no_clusters,startTime,q,feasible)
% ZIGPLOT plot Gantt diagram of TDMA schedule 
%
% PARAMETERS:
%   p  
%   dedication    
%   task_labels 
%   proc_labels     
%   no_clusters     total number of clusters
%   startTime  
%   q
%   feasible
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%disply only non-dummy tasks
p=p(2:no_clusters);
dedication=dedication(2:no_clusters);
task_labels=task_labels(2:no_clusters);
startTime=startTime(2:no_clusters);

%proc_assignment = result.proc_assignment;

% Expand names of processors
capNoInf = ones(length(proc_labels),1);
capNoInf(find(capNoInf==Inf)) = 1;
proc_labels_exp = {};
for i=1:length(capNoInf)
    for j = 1:capNoInf(i)
        proc_labels_exp{end+1} = proc_labels{i};
    end
end

% Expand multiprocessor tasks
if(~isempty(startTime) && feasible~=0)
    pplot_hi = [];
    stplot_hi =[];
    colorplot_hi = [];
    task_labels_plot_hi = [];
    dedic_hi = [];
    pplot_lo = [];
    stplot_lo =[];
    colorplot_lo = [];
    task_labels_plot_lo = [];
    dedic_lo = [];
    colors = colorfromcolormap(1+length(p));      %Generate RGB colors for tasks
    colors(1,:) = [0.9,0.9,0.9]; %add PJU
    %Expand multiprocessor tasks
    ii=0;
    for(i=1:length(p))
        for(j=1:length(dedication{i}))
            ii=ii+1;
            if j==1
                pplot_hi(end+1) = p(i);
                stplot_hi(end+1) = startTime(i);
                task_labels_plot_hi{end+1} = task_labels{i}; %[num2str(ii),task_labels{i}];
                colorplot_hi(end+1,:) = colors(1+i,:);
                dedic_hi(end+1)=dedication{i}(j);
            else
                pplot_lo(end+1) = p(i);
                stplot_lo(end+1) = startTime(i);
                task_labels_plot_lo{end+1} = task_labels{i}; %[num2str(ii),task_labels{i}]; %'';
                colorplot_lo(end+1,:) = colors(1,:);
                dedic_lo(end+1)=dedication{i}(j);
            end
            %dedic(end+1) = sum(capNoInf(1:(dedication{i}(j)-1)))+proc_assignment{i}(j);
         end
    end
    pplot = [pplot_lo,pplot_hi];
    stplot =[stplot_lo,stplot_hi];
    colorplot = [colorplot_lo;colorplot_hi];
    task_labels_plot = [task_labels_plot_lo,task_labels_plot_hi];
    dedic = [dedic_lo,dedic_hi];
    %Create nodified taskset
    TS=taskset(pplot);
    TS.Name=task_labels_plot;
    TS=colour(TS,colorplot);
    add_schedule(TS,'ILP rozvrh',stplot,pplot,dedic);
    Cmax = max(stplot+pplot);
    plot(TS,'Axis',[0 Cmax],'Axname',proc_labels_exp,'Prec',1);
else
    plot([0 0]);
end

return

%end of file
